function [d2] = diff2D_2_diag(nrows,ncols)

%[d2] = diff2D_2_diag(nrows,ncols);
%
%Generates sparse matrix of -6, 1's, and 1/2's for calculating second 
%finite difference includian diagonals (laplacian) in 2D using a 9 point 
%scheme.  DOES NOT SPECIiFY BOUNDARY CONDITIONS or GRID SPACING.
%
%|1/2  1  1/2|
%| 1  -6   1 |
%|1/2  1  1/2|, = average of regular and diagonal grids.
%
%Copyright (C) 2013 Adam M. Booth, [bootha@caltech.edu].
%
%-------------------------------------------------------------------------%
%This program is free software: you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation, either version 3 of the License, or
%any later version.
%
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
%
%You should have received a copy of the GNU General Public License
%along with this program.  If not, see <http://www.gnu.org/licenses/>.
%-------------------------------------------------------------------------%
 
len = nrows*ncols;
d = ones(len,1);
d2 = spdiags([0.5*d d 0.5*d d -6*d d 0.5*d d 0.5*d],...
    [-nrows-1 -nrows -nrows+1 -1 0 1 nrows-1 nrows nrows+1],len,len);

end